Index: issm/trunk/src/m/plot/plot_transient_movie.js
===================================================================
--- issm/trunk/src/m/plot/plot_transient_movie.js	(revision 25994)
+++ issm/trunk/src/m/plot/plot_transient_movie.js	(revision 26744)
@@ -1,119 +1,177 @@
-function plot_transient_movie(md, options, canvas) {//{{{
-	/**
-	 * PLOT_TRANSIENT_MOVIE - plot a transient result as a movie
-	 *
-	 * Usage:
-	 *	plot_transient_movie(md, options, canvas);
-	 *
-	 * See also: PLOTMODEL, PLOT_MANAGER
-	 */
+'use strict';
 
-	// Loop over the time steps
-	let data	 	= options.getfieldvalue('transient_field_data');
-	let dataType	= {};
-	let steps 		= new Array(data.length);
-
-	for (let i = 0, numSteps = steps.length; i < numSteps; ++i) {
+/**
+ * Global Function: plot_transient_movie
+ *
+ * Parameters:
+ *		options			- Object containing a number of property/value pairs.
+ *		animation		- Object containing a number of property/value pairs related to transient solution animation.
+ *		progressText	- Object containing a number of property/value pairs related to updating the playback slider text on frame change.
+ *		unit 			- String (default: '') which is appended to the frame index with a single white space before updating #playback-progress-text on frame change.
+ *		update			- Boolean (default: true) indicating whether or not to update #playback-progress-text on frame change with the frame index. Set this to 'false' if you would rather manage the update of #playback-progress-text via 'onMovieUpdate' handler (or by some other means).
+ * 
+ * See Also:
+ *		- /web/js/plotmodel.js
+ *		- /web/js/plot_manager.js
+ *
+ * TODO:
+ *		- Update function signature/handling to use ES6 default parameters for 'unit' and 'handling'.
+ */
+function plot_transient_movie(md, options, canvas) {
+	//loop over the time steps
+	let data = options.getfieldvalue('transient_field_data');
+	let steps = new Array(data.length);
+	
+	for (let i = 0; i < steps.length; i++) {
 		steps[i] = i;
 	}
-
-	// Calculate caxis
+	
+	//calculate caxis
 	if (!options.exist('caxis')) {
-		let range 			= [Infinity, -Infinity];
-		let	dataResults;
-
+		let range = [Infinity, -Infinity];
+		let dataresults;
 		for (let i in steps) {
-			dataResults = processdata(md, data[i], options);
-			range[0] = Math.min(range[0], ArrayMin(dataResults[1]));
-			range[1] = Math.max(range[1], ArrayMax(dataResults[1]));
+			dataresults = processdata(md, data[i], options);
+			range[0] = Math.min(range[0], ArrayMin(dataresults[1]));
+			range[1] = Math.max(range[1], ArrayMax(dataresults[1]));
 		}
-
-		dataType = dataResults[1];
 		options.addfielddefault('caxis', range);
 	}
+	
+	//Create unit node 
+	let dataresults = processdata(md, data[0], options);
+	let data2 = dataresults[0]; 
+	let datatype = dataresults[1];
+	plot_unit(md, data2, datatype, options, canvas);
+	let unitOptions = options.getfieldvalue('unitOptions', {'name' : 'unit'});
+	let unitName 	= unitOptions.name;
+	let node 		= canvas.unitNodes[unitName];
+	
+	//process data
+	let processedData = [];
+	for (let i in steps) {
+		dataresults = processdata(md, data[i].slice(), options);
+		processedData[i] = dataresults[0];
+	}
+	
+	//process mesh
+	let meshresults = processmesh(md, data2, options);
+	meshresults = scaleMesh(md, meshresults, options);
+	let x = meshresults[0]; 
+	let y = meshresults[1]; 
+	let z = meshresults[2]; 
+	let elements = meshresults[3];
+	let is2d = meshresults[4]; 
+	let isplanet = meshresults[5];
+	let vertices = meshresults[6];
+	let scale = meshresults[7];
+	
+	//process options
+	if (canvas.animation !== undefined && canvas.animation.handler !== undefined) {
+		clearInterval(canvas.animation.handler);
+	}
+	let animation = options.getfieldvalue('animation', {});
+	
+	let progressText = null;
+	if (!vesl.helpers.isEmptyOrUndefined(animation.progressText)) {
+		progressText = {
+					update	: defaultFor(animation.progressText.update, true),
+					unit	: defaultFor(animation.progressText.unit,  	'')
+				};
+	} else {
+		progressText = {
+					update	: false,
+					unit	: ''
+				};
+	}
+	canvas.animation = {
+		frame: defaultFor(animation.frame, 			0),
+		play: defaultFor(animation.play, 			true),
+		fps: defaultFor(animation.fps, 				4),
+		interval: defaultFor(animation.interval, 	1000 / defaultFor(animation.fps, 4)),
+		loop: defaultFor(animation.loop, 			true),
+		handler: 						{}, // Initialized below
+		progressText: 						progressText
+	}
+	//display movie
+	canvas.unitMovieData = processedData;
+	canvas.animation.totalFrames = processedData.length;
+	canvas.animation.frame = 0;
 
-	// Create unit node if it does not already exist
-	if (!('unit' in canvas.nodes)) {
-		let	dataResults = processdata(md, data[0],options);
-		let	data2 		= dataResults[0];
-		let	dataType 	= dataResults[1];
-
-		// Plot unit
-		plot_unit(md,data2,dataType,options,canvas);
+	let slider = null;
+	
+	if (!vesl.helpers.isEmptyOrUndefined(canvas.playbackControls)) {
+		if (!vesl.helpers.isEmptyOrUndefined(canvas.playbackControls.slider)) {
+			slider = canvas.playbackControls.slider;
+		}
+		
+		
+		if (!vesl.helpers.isEmptyOrUndefined(canvas.playbackControls.progressText)) {
+			progressText = canvas.playbackControls.progressText;
+		}
 	}
-
-	// Setup rendering node
-	let node = canvas.nodes.unit;
-
-	node.options 	= options;
-	node.alpha 		= options.getfieldvalue('alpha', 1.0);
-	node.caxis 		= options.getfieldvalue('caxis');
-	node.enabled 	= options.getfieldvalue('nodata', 'off') === 'off';
-	node.log 		= options.getfieldvalue('log', false);
-
-	// Process data
-	let	dataResults;
-	let processedData = [];
-
-	for (let i in steps) {
-		dataResults 		= processdata(md, data[i].slice(), options);
-		processedData[i] 	= dataResults[0];
-	}
-
-	// Display movie
-	canvas.unitMovieData		= processedData;
-	canvas.animation.frame 		= 0;
-	canvas.animation.handler 	= setInterval(function () {
+	
+	clearInterval(canvas.animation.handler);
+	canvas.animation.handler = setInterval(function() {
 		// Update current animation frame
-		let frame 		= canvas.animation.frame;
-		let numFrames 	= steps.length;
-
+		let frame = canvas.animation.frame;
+		
 		if (canvas.animation.play) {
-			if (canvas.animation.increment) {
-				if (frame >= numFrames - 1) {
-					if (canvas.animation.loop) {
-						frame = 0;
-					} else {
-						toggleMoviePlay(canvas);
-					}
+			if (frame >= steps.length - 1) {
+				if (canvas.animation.loop) {
+					frame = 0;
 				} else {
-					frame = (frame + 1) % numFrames;
+					canvas.animation.play = !canvas.animation.play;
 				}
+			} else {
+				frame = (frame + 1) % steps.length;
 			}
 		}
-
-		// If frame has changed, update unit node and data marker display
+		
+		//If frame has changed, update unit node and data marker display.
 		if (frame !== canvas.animation.lastFrame) {
+			canvas.state.dispatchEvent('onMovieUpdate', canvas, frame, node);
+			
+			//Rescale in case surface has changed
+			if (md.mesh.classname() === 'mesh3dsurface' || md.mesh.classname() === 'mesh3dprisms') {
+				vertices = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false, 'reproject':false}), true);
+			} else {
+				vertices = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false, 'reproject':false}), true);
+				//vertices = [x, y, z];
+			}
+	
+			node.updateBuffer('Vertices', vertices);
 			node.updateBuffer('Coords', processedData[frame]);
-			canvas.unitData = processedData[frame];
-
+			canvas.unitData[unitName] = processedData[frame];
 			if (canvas.graph.enabled) {
 				vesl.graph.draw(canvas);
 			}
-
-			if (!vesl.helpers.isEmptyOrUndefined(canvas.playbackControls.slider)) {
-				canvas.playbackControls.slider.val(frame);
+			if (slider != null) {
+				slider.val(frame);
 			}
-
-			if (!vesl.helpers.isEmptyOrUndefined(canvas.playbackControls.progressText)) {
-				canvas.playbackControls.progressText.html(steps[frame].toFixed(0) + ' ' + options.getfieldvalue('movietimeunit', 'yr'));
+			if (!vesl.helpers.isEmptyOrUndefined(progressText) && canvas.animation.progressText.update) {
+				if (canvas.animation.progressText.unit === '') {
+					progressText.html(steps[frame].toFixed(0));
+				} else {
+					progressText.html(steps[frame].toFixed(0) + ' ' + canvas.animation.progressText.unit);
+				}
 			}
-
-			if (!vesl.helpers.isEmptyOrUndefined(canvas.nodes.quiver)) {
-				plot_quiver(md, options, canvas, false);
-			}
+			//if (!vesl.helpers.isEmptyOrUndefined(canvas.nodes.quiver)) {
+			//	plot_quiver(md,options,canvas,false);
+			//}
+			
 		}
-
-		// Save new frame info
-		canvas.animation.lastFrame 	= canvas.animation.frame;
-		canvas.animation.frame 		= frame;
+		
+		//Save new frame info.
+		canvas.animation.lastFrame = canvas.animation.frame;
+		canvas.animation.frame = frame;
 	}, canvas.animation.interval);
-
-	// Update progress bar with new frame info
-	if (!vesl.helpers.isEmptyOrUndefined(canvas.playbackControls.slider)) {
-		canvas.playbackControls.slider.val(canvas.animation.frame);
-		canvas.playbackControls.slider.setUpperBound(steps.length - 1);
+	
+	//Update progress bar with new frame info.
+	if (!vesl.helpers.isEmptyOrUndefined(slider)) {
+		slider.max(steps.length - 1);
+		slider.val(canvas.animation.frame);
 	}
-
+				
 	applyoptions(md, [], options, canvas);
-}//}}}
+}
Index: issm/trunk/src/m/plot/plot_unit.js
===================================================================
--- issm/trunk/src/m/plot/plot_unit.js	(revision 25994)
+++ issm/trunk/src/m/plot/plot_unit.js	(revision 26744)
@@ -1,2 +1,4 @@
+'use strict';
+
 function plot_unit(md, data, datatype, options, canvas) { //{{{
 	//PLOT_UNIT - unit plot, display data
@@ -6,121 +8,123 @@
 	//
 	//   See also: PLOTMODEL, PLOT_MANAGER
-
-	var name = 'unit';
-	if ('unit' in canvas.nodes) {
-		if (options.getfieldvalue('clf','on')=='on') {
-			for (var node in canvas.nodes) {
-				if (vesl.string.startsWith(node, 'unit')) {
-					delete canvas.octrees[node];
-					delete canvas.nodes[node];
-				}
+	
+	//{{{
+	// Process data and model
+	let meshresults = processmesh(md, data, options);
+	meshresults = scaleMesh(md, meshresults, options);
+	let x = meshresults[0]; 
+	let y = meshresults[1]; 
+	let z = meshresults[2]; 
+	let elements = meshresults[3];
+	let is2d = meshresults[4]; 
+	let isplanet = meshresults[5];
+	let vertices = meshresults[6];
+	let scale = meshresults[7];
+	
+	//Compute gl variables:
+	let edgecolor = options.getfieldvalue('edgecolor', [1.0, 1.0, 1.0, 1.0]);
+	let maskzeros = options.getfieldvalue('maskzeros', {});
+	
+	let unitOptions = options.getfieldvalue('unitOptions', {'name' : 'unit'});
+	let unitName 	= unitOptions.name;
+	
+	let node = new Node(
+		'canvas', canvas,
+		'options', options,
+		'md', md,
+		'name', unitName,
+		'shaderName', 'unit',
+		'opacity', options.getfieldvalue('opacity', 1.0),
+		'caxis', options.getfieldvalue('caxis',[ArrayMin(data), ArrayMax(data)]),
+		'cullFace', THREE.FrontSide,
+		'enabled', options.getfieldvalue('nodata', 'off') === 'off',
+		'log', options.getfieldvalue('log',false),
+		'maskObject', options.getfieldvalue('maskregion', {'enabled': false}),
+		'maskZerosColor', defaultFor(maskzeros.color, [1.0, 1.0, 1.0, 1.0]),
+		'maskZerosEnabled', defaultFor(maskzeros.enabled, false),
+		'maskZerosTolerance', defaultFor(maskzeros.tolerance, 1e-3),
+		'maskZerosZeroValue', defaultFor(maskzeros.zeroValue, 0.5),
+		'scale', scale
+	);
+	//}
+	
+	if (vesl.helpers.isEmptyOrUndefined(canvas.unitNodes)) {
+		canvas.unitNodes = {};
+	}
+	
+	if (vesl.helpers.isEmptyOrUndefined(canvas.unitData)) {
+		canvas.unitData = {};
+	}
+	
+	// If option 'clf' is on, remove all cached data associated with this unit
+	if (options.getfieldvalue('clf', 'on') === 'on') {
+		delete canvas.unitNodes[unitName];
+		canvas.unitData[unitName] = data;
+		
+		for (let i = 0, numUnits = canvas.state.scene.children.length; i < numUnits; ++i) {
+			if (canvas.state.scene.children[i].name === unitName) {
+				canvas.state.scene.children.splice(i, 1);
+				break;
 			}
 		}
-		else {
-			name = 'unit' + Object.keys(canvas.nodes).length;
-		}
-	}
-
-	//{{{ declare variables:
-	//Process data and model
-	var meshresults = processmesh(md, data, options);
-	var x = meshresults[0]; 
-	var y = meshresults[1]; 
-	var z = meshresults[2]; 
-	var elements = meshresults[3];
-	var is2d = meshresults[4]; 
-	var isplanet = meshresults[5];
-	if (md.mesh.classname() !== 'mesh3dsurface') {
-		if (vesl.helpers.isNaN(md.geometry.surface) || (md.geometry.surface[0] !== undefined && vesl.helpers.isNaN(md.geometry.surface[0]))) {
-			md.geometry.surface = NewArrayFill(x.length, 0);
-		}
-		z = md.geometry.surface;
 	}
 	
-	//Compute coordinates and data range:
-	var xlim = options.getfieldvalue('xlim', [ArrayMin(x), ArrayMax(x)]);
-	var ylim = options.getfieldvalue('ylim', [ArrayMin(y), ArrayMax(y)]);
-	var zlim = options.getfieldvalue('zlim', [ArrayMin(z), ArrayMax(z)]);
+	canvas.unitNodes[unitName] = node;
 	
-	//Handle heightscale
-	var vertices, scale;
-	if (md.mesh.classname() !== 'mesh3dsurface') {
-		vertices = [x, y, z];
-		scale = [1, 1, options.getfieldvalue('heightscale', 1)];
-	}
-	else {
-		vertices = Node.prototype.scaleVertices(md, x, y, z, elements, options.getfieldvalue('heightscale', 1), options.getfieldvalue('maskregion',{'enabled':false}));
-		scale = [1, 1, 1];
-	}
-
-	//Compute gl variables:
-	var edgecolor = options.getfieldvalue('edgecolor', [1.0, 1.0, 1.0 ,1.0]);
-	var maskzeros = options.getfieldvalue('maskzeros', {});
-	var render = options.getfieldvalue('render', {});
-	var cullFace = ("unit" in render) ? canvas.gl[render.unit.cullFace] : canvas.gl.BACK;
-	var node = new Node(
-		'canvas', canvas,
-		'options', options,
-		'name', name,
-		'shaderName', 'TexturedDiffuse',
-		'alpha', options.getfieldvalue('alpha', 1.0),
-		'caxis', options.getfieldvalue('caxis',[ArrayMin(data), ArrayMax(data)]),
-		'center', [(xlim[0] + xlim[1]) / 2, (ylim[0] + ylim[1]) / 2, (zlim[0] + zlim[1]) / 2],
-		'cullFace', cullFace,
-		'lightingBias', canvas.view.lightingBias,
-		'diffuseColor', edgecolor,
-		'specularStrength', 0.0,
-		'enabled', options.getfieldvalue('nodata','off') == 'off' || (("unit" in render) && render.unit.enabled),
-		'log', options.getfieldvalue('log',false),
-		'maskEnabled', options.getfieldvalue('innermask','off') == 'on',
-		'maskHeight', options.getfieldvalue('innermaskheight', 150.0) / options.getfieldvalue('heightscale', 1),
-		'maskColor', options.getfieldvalue('innermaskcolor',[0.0, 0.0, 1.0, 1.0]),
-		'maskObject', options.getfieldvalue('maskregion',{'enabled':false}),
-		'maskZerosColor', defaultFor(maskzeros.color,[1.0, 1.0, 1.0, 1.0]),
-		'maskZerosEnabled', defaultFor(maskzeros.enabled,false),
-		'maskZerosTolerance', defaultFor(maskzeros.tolerance,1e-3),
-		'maskZerosZeroValue', defaultFor(maskzeros.zeroValue,0.5),
-		'rotation', [-90, 0, 0],
-		'scale', ("unit" in render) ? [render.unit.scale, render.unit.scale, render.unit.scale] : scale
-	);
-	//}
-	if (options.getfieldvalue('clf','on')=='on') {
-		canvas.unitNode = node;
-		canvas.unitData = data;
-	}
 	//}}}
-	switch(datatype){
+	switch(datatype) {
 		//{{{ element plot
 		case 1:
 			//WARNING: NaN are not properly found (NaN != NaN = true)
-			pos=ArrayFindNot(data, NaN); //needed for element on water
-			if (elements[0].length==6){ //prisms
-			}
-			else if (elements[0].length==4){ //tetras
-			}
-			else{ //triangular elements
+			let pos = ArrayFindNot(data, NaN); //needed for element on water
+			
+			if (elements[0].length === 6) { // prisms
+				let abc = elements.map(function(value, index) { return [value[0], value[1], value[2]]; }); //top
+				let dfe = elements.map(function(value, index) { return [value[3], value[5], value[4]]; }); //bottom
+				let aeb = elements.map(function(value, index) { return [value[0], value[4], value[1]]; }); //1st side upper right
+				let ade = elements.map(function(value, index) { return [value[0], value[3], value[4]]; }); //1st side lower left
+				let bfc = elements.map(function(value, index) { return [value[1], value[5], value[2]]; }); //2nd side upper right
+				let bef = elements.map(function(value, index) { return [value[1], value[4], value[5]]; }); //2nd side lower left
+				let cda = elements.map(function(value, index) { return [value[2], value[3], value[0]]; }); //3rd side upper right
+				let cfd = elements.map(function(value, index) { return [value[2], value[5], value[3]]; }); //3rd side lower left
+				let prismElements = abc.concat(dfe, aeb, ade, bfc, bef, cda, cfd);
+				node.patch('Faces', prismElements, 'Vertices', vertices, 'FaceVertexCData', data, 'FaceColor', 'flat', 'EdgeColor', edgecolor);
+			} else if (elements[0].length === 4) { // tetras
+    			// TODO: Implement handling for tetras
+			} else { // triangular elements
 				node.patch('Faces', elements, 'Vertices', vertices, 'FaceVertexCData', data, 'FaceColor', 'flat', 'EdgeColor', edgecolor);
 			}
+			
 			break;
 		//}}}
 		//{{{ node plot
 		case 2:
-			if (elements[0].length==6){ //prisms
-			}
-			else if (elements[0].length==4){ //tetras
-			}
-			else{ //triangular elements	
+			if (elements[0].length === 6) { // prisms
+				let abc = elements.map(function(value, index) { return [value[0], value[1], value[2]]; }); //top
+				let dfe = elements.map(function(value, index) { return [value[3], value[5], value[4]]; }); //bottom
+				let aeb = elements.map(function(value, index) { return [value[0], value[4], value[1]]; }); //1st side upper right
+				let ade = elements.map(function(value, index) { return [value[0], value[3], value[4]]; }); //1st side lower left
+				let bfc = elements.map(function(value, index) { return [value[1], value[5], value[2]]; }); //2nd side upper right
+				let bef = elements.map(function(value, index) { return [value[1], value[4], value[5]]; }); //2nd side lower left
+				let cda = elements.map(function(value, index) { return [value[2], value[3], value[0]]; }); //3rd side upper right
+				let cfd = elements.map(function(value, index) { return [value[2], value[5], value[3]]; }); //3rd side lower left
+				let prismElements = abc.concat(dfe, aeb, ade, bfc, bef, cda, cfd);
+				node.patch('Faces', prismElements, 'Vertices', vertices, 'FaceVertexCData', data, 'FaceColor', 'interp', 'EdgeColor', edgecolor);
+			} else if (elements[0].length === 4) { // tetras
+    			// TODO: Implement handling for tetras
+			} else { // triangular elements	
 				node.patch('Faces', elements, 'Vertices', vertices, 'FaceVertexCData', data, 'FaceColor', 'interp', 'EdgeColor', edgecolor);
 			}
+			
 			break;
 		//}}}
 		//{{{ quiver plot 
 		case 3:
-			if (is2d){
+			if (is2d) {
 				//plot_quiver(x, y, data(:, 1), data(:, 2), options);
-			}
-			else{
+			} else {
 				//plot_quiver3(x, y, z, data(:, 1), data(:, 2), data(:, 3), options);
 			}
+			
 			break;
 		//}}}
Index: issm/trunk/src/m/plot/plotdoc.js
===================================================================
--- issm/trunk/src/m/plot/plotdoc.js	(revision 25994)
+++ issm/trunk/src/m/plot/plotdoc.js	(revision 26744)
@@ -24,5 +24,5 @@
 	console.log('       	"height": height to spawn clouds at (ex: 7500)');
 	console.log('       	"quantity": quantity of clouds to spawn (ex: 10)');
-	console.log('       "caxis": modify  colorbar range. (array of type [a, b] where b>=a)');
+	console.log('       "caxis": modify colorbar range (array of type [a, b] where b>=a)');
 	console.log('       "colorbar": add colorbar (default "off", ex: "on", "off")');
 	console.log('       "colorbarid": colorbar canvas id (string)');
@@ -39,9 +39,10 @@
 	console.log('       "dataMarker": object cotaining data marker parameters. See webgl.js for defaults. (ex: {"enabled":true,"format":["<div id="sim-plot"></div>"],"labels":["thickness","velocity","value"],"animated":true})');
 	console.log('       	"enabled": toggle data marker displays (default true, ex: false)');
-	console.log('       	"image": image used for marking the clicked point (ex: "/canvas/data-markers/data-marker.svg")');
-	console.log('       	"labels": when displaying a sim-plot graph, display these model fields. (ex: ["thickness","velocity","value"])');
-	console.log('       	"font": font to be used for display (ex: "24px "Comic Sans MS", cursive")');
-	console.log('       	"format": an array compatible with sprintf that will be displayed as html (ex: ["X: %.2e<br>Y: %.2e<br>Z: %.2e]<br>Value: %0.1f","x","y","z","value"])');
-	console.log('      		"size": specifiy the width and height of the data markers (default [32,32], ex: [24,32], [105,10])');
+	console.log('       	"hasMarker": whether or not the data marker has a marker (default true, ex: false)');
+	console.log('       	"markerImgPath": path to image to use for marker (default "/canvas/data-markers/data-marker.svg")');
+	console.log('       	"hasTooltip": whether or not the data marker has a tooltip (default false, ex: true)');
+	console.log('       	"tooltipFormat": C-style format string to be used when on calls to vesl.DataMarker.tooltipContent to format passed data points (default "", ex: ["X: %.2e<br>Y: %.2e<br>Z: %.2e])');	
+	console.log('       	"width": width, in pixels, of the data marker (default 32)');	
+	console.log('       	"height": height, in pixels, of the data marker (default 32)');
 	console.log('       "displayview": print view value to console (default "off", ex: "on", "off")');
 	console.log('       "displayzoom": print zoom value to console (default "off", ex: "on", "off")');
@@ -60,8 +61,8 @@
 	console.log('       "outermask*": Special mask that colors all parts of a overlay mesh below a height a certain color. provide outermaskheight and outermaskcolor options also (default "off", ex: "on", "off")');
 	console.log('       "overlay": overlay a radar amplitude image behind (default "off", ex: "on", "off")');
-	console.log('       "overlay_image": path to overlay image (default "", ex: "./images/radar.png")');
+	console.log('       "overlay_image": path to overlay image (default "", ex: "./img/radar.png")');
 	console.log('       "quiver": add quiver plot overlay for velocities. (default "off", ex: "on", "off")');
 	console.log('       "scaling": scaling factor used by quiver plots. Default is 0.4');
-	console.log('       "alpha": transparency coefficient 0.0 to 1.0, the lower, the more transparent. (default 1.0, ex: 0.5, 0.25)');
+	console.log('       "opacity": transparency coefficient 0.0 to 1.0, the lower, the more transparent. (default 1.0, ex: 0.5, 0.25)');
 	console.log('       "render": a object containing a list of default object to render. (default {}, ex: {"sky", "space"})');
 	console.log('       	"sky": render the atmosphere. (ex: {"enabled":true})');
Index: issm/trunk/src/m/plot/plotdoc.m
===================================================================
--- issm/trunk/src/m/plot/plotdoc.m	(revision 25994)
+++ issm/trunk/src/m/plot/plotdoc.m	(revision 26744)
@@ -122,5 +122,5 @@
 disp('       ''mask'': list of flags of size numberofnodes or numberofelements. Only ''true'' values are plotted ');
 disp('       ''nan'': value assigned to NaNs (convenient when plotting BC)');
-disp('       ''partitionedges'': ''off'' by default. overlay plot of partition edges');
+disp('       ''partition'': a partion vector. generates overlay plot of partition edges');
 disp('       ''log'': value of log');
 disp('       ''latlon'': ''on'' or {latstep lonstep [resolution [color]]} where latstep,longstep and resolution are in degrees, color is a [r g b] array');
Index: issm/trunk/src/m/plot/plotdoc.py
===================================================================
--- issm/trunk/src/m/plot/plotdoc.py	(revision 25994)
+++ issm/trunk/src/m/plot/plotdoc.py	(revision 26744)
@@ -127,5 +127,5 @@
     #                'border': " size of printlay border (in pixels). active only for overlay plots",
     #                'nan': " value assigned to NaNs (convenient when plotting BC)",
-    #                'partitionedges': " 'off' by default. overlay plot of partition edges",
+    #                'partition: " a partion vector. generates overlay plot of partition edges",
     #                'latlon': " 'on' or {latstep lonstep [resolution [color]]} where latstep, longstep and resolution are in degrees, color is a [r g b] array",
     #                'latlonnumbering': " 'on' or {latgap longap colornumber latangle lonangle} where latgap and longap are pixel gaps for the numbers",
Index: issm/trunk/src/m/plot/plotmodel.js
===================================================================
--- issm/trunk/src/m/plot/plotmodel.js	(revision 25994)
+++ issm/trunk/src/m/plot/plotmodel.js	(revision 26744)
@@ -1,45 +1,54 @@
-function plotmodel(md){ //{{{
-	//Convert arguments to array: 
-	var args = Array.prototype.slice.call(arguments);
+'use strict';
 
-	//First process options
-	var options = new plotoptions(args.slice(1,args.length));
+function plotmodel(md) { //{{{
+	let args            = Array.prototype.slice.call(arguments); // Convert arguments to array 
+    let canvas          = null;
+    let ncols           = 0;
+    let nlines          = 0;
+    let numberofplots   = 0;
+    let options         = new plotoptions(args.slice(1, args.length)); // Process options
+    let subplotwidth    = Math.ceil(Math.sqrt(options.numberofplots)); // Get number of subplots
+    
+	// Get figure number and number of plots
+	numberofplots = options.numberofplots;
+
+	// If nlines and ncols specified, then bypass.
+	if (options.list[0].exist('nlines')) {
+		nlines = options.list[0].getfieldvalue('nlines');
+	} else {
+		nlines = Math.ceil(numberofplots / subplotwidth);
+	}
 	
-	//get number of subplots
-	subplotwidth=Math.ceil(Math.sqrt(options.numberofplots)); 
-	
-	//Get figure number and number of plots
-	numberofplots=options.numberofplots;
-
-	//if nlines and ncols specified, then bypass.
-	var nlines,ncols;
-	if (options.list[0].exist('nlines')){
-		nlines=options.list[0].getfieldvalue('nlines');
-	}
-	else {
-		nlines=Math.ceil(numberofplots/subplotwidth);
-	}
 	if (options.list[0].exist('ncols')){
-		ncols=options.list[0].getfieldvalue('ncols');
-	}
-	else {
-		ncols=subplotwidth;
+		ncols = options.list[0].getfieldvalue('ncols');
+	} else {
+		ncols = subplotwidth;
 	}
 	
 	//check that nlines and ncols were given at the same time!
-	if ((options.list[0].exist('ncols') & !options.list[0].exist('nlines')) | (options.list[0].exist('nlines') & !options.list[0].exist('ncols'))) throw Error('plotmodel error message: nlines and ncols need to be specified together, or not at all');
+	if ((options.list[0].exist('ncols') && !options.list[0].exist('nlines')) 
+	    || ((options.list[0].exist('nlines') && !options.list[0].exist('ncols')))) {
+    	    throw Error('plotmodel error message: nlines and ncols need to be specified together, or not at all');
+    }
 
-	//go through subplots
-	if (numberofplots){
-		//Reinitialize all canvases
-		for (var i=0;i<numberofplots;i++){
-			if (options.list[i].getfieldvalue('clf','on')!='off') document.getElementById(options.list[i].getfieldvalue('canvasid')).initialized = false;
+	// Go through subplots
+	if (numberofplots) {
+		// Go through all data plottable and close window if an error occurs
+
+		let canvases = [];
+		for (let i = 0; i < numberofplots; ++i) {
+			canvases[i] = document.getElementById(options.list[i].getfieldvalue('canvasid'));
+			canvases[i].state.dispatchEvent('onPlotModelStart', canvases[i], options.list[i]);
 		}
-		//Go through all data plottable and close window if an error occurs
-		for (var i=0;i<numberofplots;i++){
-			plot_manager(options.list[i].getfieldvalue('model',md),options.list[i],subplotwidth,nlines,ncols,i);
+		for (let i = 0; i < numberofplots; ++i) {
+			canvases[i].state.dispatchEvent('onPlotManagerStart', canvases[i], options.list[i]);
+			plot_manager(options.list[i].getfieldvalue('model',md), options.list[i], subplotwidth, nlines, ncols, i);
+			canvases[i].state.dispatchEvent('onPlotManagerEnd', canvases[i], options.list[i]);
 
-			//List all unused options
+			// List all unused options
 			options.list[i].displayunused();
+		}
+		for (let i = 0; i < numberofplots; ++i) {
+			canvases[i].state.dispatchEvent('onPlotModelEnd', canvases[i], options.list[i]);
 		}
 	}
Index: issm/trunk/src/m/plot/plotmodel.py
===================================================================
--- issm/trunk/src/m/plot/plotmodel.py	(revision 25994)
+++ issm/trunk/src/m/plot/plotmodel.py	(revision 26744)
@@ -14,5 +14,5 @@
 def plotmodel(md, *args):
     '''
-    PLOTMODEL - At command prompt, type 'plotdoc()' for additional 
+    PLOTMODEL - At command prompt, type 'plotdoc()' for additional
     documentation.
 
@@ -31,5 +31,5 @@
     subplotwidth = ceil(sqrt(numberofplots))
 
-    # TODO: Check that commenting this out is correct; we do not need a hold 
+    # TODO: Check that commenting this out is correct; we do not need a hold
     # under matplotlib, right?
     #
@@ -60,5 +60,5 @@
     # Go through plots
     #
-    # NOTE: The following is where Python + matplolib differs substantially in 
+    # NOTE: The following is where Python + matplolib differs substantially in
     #       implementation and inteface from MATLAB.
     #
@@ -83,5 +83,5 @@
             plotnum = None
 
-        # NOTE: The inline comments for each of the following parameters are 
+        # NOTE: The inline comments for each of the following parameters are
         #       taken from https://matplotlib.org/api/_as_gen/mpl_toolkits.axes_grid1.axes_grid.ImageGrid.html
         #
@@ -95,5 +95,5 @@
         #
         # TODO:
-        # - Add 'edge' option (research if there is a corresponding option in 
+        # - Add 'edge' option (research if there is a corresponding option in
         #   MATLAB)?
         #
@@ -118,5 +118,5 @@
         #   rect(float, float, float, float) or int
         #
-        # The axes position, as a (left, bottom, width, height) tuple or as a 
+        # The axes position, as a (left, bottom, width, height) tuple or as a
         # three-digit subplot position code (e.g., "121").
         #
@@ -127,5 +127,4 @@
             direction=direction,
             axes_pad=axes_pad,
-            add_all=add_all,
             share_all=share_all,
             label_mode=label_mode,
Index: issm/trunk/src/m/plot/processdata.m
===================================================================
--- issm/trunk/src/m/plot/processdata.m	(revision 25994)
+++ issm/trunk/src/m/plot/processdata.m	(revision 26744)
@@ -164,5 +164,5 @@
 			data(pos,:)=maskvalue;
 		else
-			disp('plotmodel warning: mask length not supported yet (supported length are numberofvertices and numberofelements');
+			disp('Warning: processdata.m: mask length not supported yet (supported length are numberofvertices and numberofelements');
 		end
 	end
@@ -194,5 +194,5 @@
 			data(md.mesh.elements(pos,:),:)=maskvalue;
 		else
-			disp('plotmodel warning: mask length not supported yet (supported length are numberofvertices and numberofelements');
+			disp('Warning: processdata.m: mask length not supported yet (supported length are numberofvertices and numberofelements');
 		end
 	end
@@ -236,5 +236,5 @@
 			data(md.mesh.elements(pos,:),:)=NaN;
 		else
-			disp('plotmodel warning: mask length not supported yet (supported length are numberofvertices and numberofelements');
+			disp('Warning: processdata.m: mask length not supported yet (supported length are numberofvertices and numberofelements');
 		end
 	end
